/**
 * Created by Tony on 2018/6/12.
 * 专门测试项目技术经济指标类型表
 */

let test = require('tape');
const JpcEx = require("../../../modules/reports/rpt_component/jpc_ex");
const JV = require("../../../modules/reports/rpt_component/jpc_value_define");
let config = require("../../../config/config.js");
config.setupDb(process.env.NODE_ENV);
let mongoose = require("mongoose");
let fileUtils = require("../../../modules/common/fileUtils");
let path = require('path');
let dbm = require("../../../config/db/db_manager");
let rpt_cfg = require('./rpt_cfg');
dbm.connect(process.env.NODE_ENV);

//统一引用models
fileUtils.getGlobbedFiles('../../../modules/all_models/*.js').forEach(function(modelPath) {
    require(path.resolve(modelPath));
});

//config.setupCache();
let cfgCacheUtil = require("../../../config/cacheCfg");
cfgCacheUtil.setupDftCache();

let fsUtil = require("../../../public/fsUtil");
let pm_facade = require('../../../modules/pm/facade/pm_facade');

let demoPrjId = - 1;
let demoRptId = 1029; //qa 重庆2018 A03
// let demoRptId = 1005; //qa 重庆2018 A01
// let demoRptId = 1035; //qa 重庆2018 C41
// let demoRptId = 1036; //qa 重庆2018 B11
let pagesize = "A4";


// let userId_Leng = "59cdf14a0034a1000ba52b97"; //小冷User Id 换成_id了 QQ号
let userId_Leng = "5acac1e885bf55000bd055ba"; //小冷User Id2
let userId_me = "5b6a60b1c4ba33000dd417c0"; //我的
// let userId_HaiZhu = "5b5a66c4a3c23e000dccdd77"; //海珠user id
demoPrjId = 10853; //
//*/
let userId_Dft = userId_Leng;
// let userId_Dft = "5a025c4c15074d134c2b9689";
/*/
 let userId_Dft = "595328da1934dc327cad08eb";
 //*/

let rptTplFacade = require("../../../modules/reports/facade/rpt_template_facade");
let rptTplDataFacade = require("../../../modules/reports/facade/rpt_tpl_data_facade");

const rptDataExtractor = require("../../../modules/reports/util/rpt_construct_data_util");
const rpt_xl_util = require("../../../modules/reports/util/rpt_excel_util");
const rpt_pdf_util = require("../../../modules/reports/util/rpt_pdf_util");

let fs = require('fs');
//设置Date Format函数
fs.readFile(__dirname.slice(0, __dirname.length - 18) + '/public/web/date_util.js', 'utf8', 'r', function (err, data) {
    eval(data);
});

test('测试 - : ', function (t) {
    rptTplFacade.getRptTemplate(demoRptId).then(function(rptTpl) {
        let rptDataUtil = new rptDataExtractor();
        rptDataUtil.initialize(rptTpl._doc);
        let promiseArr = [null, null, null];
        let summaryRst = [], economicRst = [];
        let filter = rptDataUtil.getDataRequestFilter(summaryRst, economicRst);
        // console.log(filter);
        if (economicRst.length > 0) {
            // economicRst.push('ProjectInfoFields');
            // economicRst.push('ProjectFeatureFields');
            promiseArr[2] = pm_facade.getIndexReportData(demoPrjId, economicRst);
        }
        //正常应该根据报表模板定义的数据类型来请求数据
        rptTplDataFacade.prepareProjectData(userId_Dft, demoPrjId, filter, function (err, msg, rawDataObj) {
            if (!err) {
                try {
                    promiseArr[2].then(function (rst) {
                        let ecoFieldsRst = (rst._doc)?rst._doc:rst;
                        // fsUtil.writeObjToFile(ecoFieldsRst, "D:/GitHome/ConstructionCost/tmp/testEcoFieldsResult.jsp");
                        rawDataObj.prjData.push({moduleName: 'ProjectInfoFields', data: ecoFieldsRst.ProjectInfoFields});
                        rawDataObj.prjData.push({moduleName: 'ProjectFeatureFields', data: ecoFieldsRst.ProjectFeatureFields});
                        rawDataObj.prjData.push({moduleName: 'ProjectCostFields', data: ecoFieldsRst.ProjectCostFields});
                        rawDataObj.prjData.push({moduleName: 'ProjectEcoFields', data: ecoFieldsRst.ProjectEcoFields});
                        rawDataObj.prjData.push({moduleName: 'ProjectLabMaterialFields', data: ecoFieldsRst.ProjectLabMaterialFields});
                        rawDataObj.prjData.push({moduleName: 'ProjectQtyFields', data: ecoFieldsRst.ProjectQtyFields});

                        // fsUtil.writeObjToFile(rawDataObj, "D:/GitHome/ConstructionCost/tmp/rptTplRawDataObject_系统指标.jsp");
                        let tplData = rptDataUtil.assembleData(rawDataObj);
                        // fsUtil.writeObjToFile(rawDataObj, "D:/GitHome/ConstructionCost/tmp/rptTplRawDataAfterCacl_系统指标.jsp");
                        // fsUtil.writeObjToFile(tplData, "D:/GitHome/ConstructionCost/tmp/rptTplAssembledData_系统指标.jsp");
                        //it's time to build the report!!!
                        let printCom = JpcEx.createNew();
                        rptTpl[JV.NODE_MAIN_INFO][JV.NODE_PAGE_INFO][JV.PROP_PAGE_SIZE] = pagesize;
                        let defProperties = rpt_cfg;
                        let dftOption = JV.PAGING_OPTION_NORMAL;
                        printCom.initialize(rptTpl);
                        printCom.analyzeData(rptTpl, tplData, defProperties, dftOption, JV.OUTPUT_TYPE_EXCEL);
                        // fsUtil.writeObjToFile(tplData, "D:/GitHome/ConstructionCost/tmp/rptTplAssembledData_系统指标.jsp");
                        let maxPages = printCom.totalPages;
                        let customizeCfg = {"fillZero": true};
                        let pageRst = printCom.outputAsSimpleJSONPageArray(rptTpl, tplData, 1, maxPages, defProperties, customizeCfg);
                        if (pageRst) {
                            fsUtil.writeObjToFile(pageRst, "D:/GitHome/ConstructionCost/tmp/testBuiltPageResult_系统指标.jsp");
                            // rpt_xl_util.exportExcel(pageRst, pagesize, "local_test_rpt_excel", true, null, null, function(uuidName){
                            //     console.log("excel uuid: " + uuidName);
                            // });
                            // rpt_pdf_util.export_pdf_file(pageRst, pagesize, 'local_test_rpt_pdf', function(uuidName){
                            //     console.log("pdf uuid: " + uuidName);
                            // });
                        } else {
                            console.log("oh! no pages were created!");
                        }
                    });
                } catch (ex) {
                    console.log(ex);
                    t.pass('pass with exception!');
                    t.end();
                }

                t.pass('pass succeeded!');
                t.end();
            } else {
                console.log(msg);
                t.pass('pass with error!');
                t.end();
            }
        })
    });
});

test('close the connection', function (t) {
    setTimeout(function () {
        mongoose.disconnect();
        t.pass('closing db connection');
        t.end();
    }, 1000);
    // mongoose.disconnect();
    // t.pass('closing db connection');
    // t.end();
});